#! /bin/sh

set -e

###^^^^^^^^^^^^^^^^^^###
### Global variables ###
###__________________###

_exec="make-bootstrap.sh"
_this="$(dirname "$(readlink -f "$0")")"
_version="v0.2"

###^^^^^^^^^^^###
### Functions ###
###___________###

make_bootstrap() {
  local _cpu="$1"
  local _target="$2"
  local _system="$3"
  "$_this/make.sh" -x -o "$_this/bootstrap/$_cpu-$_target-$_system" \
    "$_cpu" "$_target" "$_system"
  find "$_this/bootstrap/$_cpu-$_target-$_system" -mindepth 1 -maxdepth 1 \
    -type d -name 'CodeC' -prune -o -exec rm -rf {} +
}

###^^^^^^^^^^^^^^^^^^^^###
### Prebuild C sources ###
###____________________###

rm -rf "$_this/bootstrap"
mkdir -p "$_this/bootstrap"
make_bootstrap 486 cpfront linux

###^^^^^^^^^^^^^^^^^^^^^^###
### Package dist sources ###
###______________________###

rm -rf "$_this/cpc-$_version"
mkdir -p "$_this/cpc-$_version"
cp -rt "$_this/cpc-$_version" -- \
  "$_this/CHANGELOG" \
  "$_this/LICENSE" \
  "$_this/README" \
  "$_this/man" \
  "$_this/crux" \
  "$_this/make.sh" \
  "$_this/make-all.sh" \
  "$_this/make-bootstrap.sh" \
  "$_this/bootstrap" \
  "$_this/src" \
  "$_this/C"
tar czf "cpc-$_version.src.tar.gz" "cpc-$_version"
